package sun.security.jgss.spi;

import org.ietf.jgss.GSSException;
import java.security.Provider;
import org.ietf.jgss.Oid;

public interface MechanismFactory
{
    public abstract Oid getMechanismOid();
    
    public abstract Provider getProvider();
    
    public abstract Oid[] getNameTypes() throws GSSException;
    
    public abstract GSSCredentialSpi getCredentialElement(GSSNameSpi p0, int p1, int p2, int p3) throws GSSException;
    
    public abstract GSSNameSpi getNameElement(String p0, Oid p1) throws GSSException;
    
    public abstract GSSNameSpi getNameElement(byte[] p0, Oid p1) throws GSSException;
    
    public abstract GSSContextSpi getMechanismContext(GSSNameSpi p0, GSSCredentialSpi p1, int p2) throws GSSException;
    
    public abstract GSSContextSpi getMechanismContext(GSSCredentialSpi p0) throws GSSException;
    
    public abstract GSSContextSpi getMechanismContext(byte[] p0) throws GSSException;
}
